﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace RCMIntegrationSample
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        //The location and port of RCM
        const string RCMURL = "https://localsystem.paygateway.com:21113/RcmService.svc/";
        //The RCM method to call
        const string RCMMETHOD = "Initialize";
        //The start of the querystring for sending the parameters
        const string QUERYSTRING = "?xl2Parameters=";
        private string _paramString;

        protected void btnPinPadSetup_Click(object sender, EventArgs e)
        {
            //Invoke the Pin Pad Device set up screen using XML parameters
            _paramString = "<XLINKEMVREQUEST>" +
                            "  <TRANSACTIONTYPE>PPDEDITSETUP</TRANSACTIONTYPE>" +
                            "</XLINKEMVREQUEST>";

            SendRequest();
        }

        protected void btnPromptForSignature_Click(object sender, EventArgs e)
        {
            //Invoke a signature prompt using XML parameters
            _paramString = "<XLINKEMVREQUEST>" +
                            "  <TRANSACTIONTYPE>PPDPROMPTSIGNATURE</TRANSACTIONTYPE>" +
                            "  <TITLE>Please Sign</TITLE>" +
                            "  <DISPLAYCAPTUREDSIGNATURE>T</DISPLAYCAPTUREDSIGNATURE>" +
                            "</XLINKEMVREQUEST>";

            SendRequest();
        }

        protected void btnCreditSale_Click(object sender, EventArgs e)
        {
            //Invoke a Credit Sale transaction using XML parameters
            _paramString = "<XLINKEMVREQUEST>'" +
            "  <TRANSACTIONTYPE>CREDITSALE</TRANSACTIONTYPE>" +
            "  <XWEBAUTHKEY>" + txtXWebAuthKey.Text + "</XWEBAUTHKEY>" +
            "  <XWEBTERMINALID>" + txtXWebTerminalID.Text + "</XWEBTERMINALID>" +
            "  <XWEBID>" + txtXWebID.Text + "</XWEBID>" +
            "  <ALLOWDUPLICATES />" +
            "  <AMOUNT>2.09</AMOUNT>" +
            "</XLINKEMVREQUEST>";

            SendRequest();
        }

        private void SendRequest()
        {
            //Send the request to RCM and get the response.  Encode the paramString.
            string url = RCMURL + RCMMETHOD + QUERYSTRING + HttpUtility.UrlEncode(_paramString);
            HttpWebRequest getRequest = (HttpWebRequest)WebRequest.Create(url);
            getRequest.Method = "GET";

            getRequest.ContentType = ddlResponseType.SelectedIndex == 2
                ? "application/xml"
                : "application/json";

            WebResponse response = getRequest.GetResponse();

            //Read the response
            Stream dataStream = response.GetResponseStream();
            StreamReader responseReader = new StreamReader(dataStream);
            txtResults.Text = responseReader.ReadToEnd();
            
            //Close connection
            responseReader.Close();
            dataStream.Close();
        }
    }
}