
// Sends a request to RcmService
// paramString: the Xl2 paramater string specifying the transaction
// url: to location of the RCM service
// port: the port the RCM service is listening on
// rcmMethod: the RCM service method to call.  (Typically "Initialize")
// handleResult: a callback function that takes the result from RCM as a paramater
function SendRequestToRcm(paramString, url, port, rcmMethod, handleResult) {
	
	try {
		
		$.ajax(
		{
			type: "GET",
			url: url + ':' + port + '/RcmService.svc/' + rcmMethod,  //https://localsystem.paygateway.com:21113/RcmService.svc/Initialize
			data: 'xl2Parameters=' + paramString,
			contentType: "application/json",
			dataType: "jsonp",
			crossDomain: true,
			jsonpCallback: 'jsonpResponse',
			cache: false,
			beforeSend: function (xhr) { xhr.setRequestHeader('Access-Control-Allow-Origin', '*'); },
			statusCode:
				{
					404: function () {
						handleResult('Could not contact server.');
					},
					500: function () {
						handleResult('A server-side error has occurred.');
					}
				},
			success: function (result) {
				handleResult(result);
				},
			error: function (result) {
				handleResult(result);
			}
		});

	} 
	catch (err) {
		handleResult('An error occured. Please restart the Remote Client Manager.');
	}
}

